#include <stdio.h>
#include <stdlib.
h>

void double_space(FILE *, FILE *);
void prn_info(char *);

int main(int argc, char **argv){ // argc: numero di parametri(+1) passati al programma, argv: parametri passati al programma
	FILE *ifp, *ofp;
	if(argc!=3){
		prn_info(argv[0]); // Stampa informazioni relative al programma (argv[0]: nome del programma)
		exit(1); 
	}
	ifp=fopen(argv[1],"r");	// Apre in lettura
	ofp=fopen(argv[2],"w");	// Apre in scrittura
	double_space(ifp,ofp);
	fclose(ifp);
	fclose(ofp);
	return 0;
}

void double_space(FILE *ifp, FILE *ofp){
	int c;
	while((c=getc(ifp)) != EOF) {
		putc(c,ofp);
		if(c=='\n')
			putc('\n',ofp); // Trovato newline, aggiunge duplicato
	}
}

void prn_info(char *pgm_name){
	printf("\n%s%s%s\n\n%s\n\n",
		"Usage: ", pgm_name, " infile outfile",
		"The contents of infile will be double-spaced and written to outfile.");
}

// gcc dbl_space.c -o dbl_space
// ./dbl_space 

