#include <stdio.h>

// Carica genoma E. coli in formato fasta
// Cerca le posizioni di tutti i codoni di start (i.e., ATG) all'interno del genoma
// Stampa su file output: lunghezza genoma, numero di codoni di start (ATG), le posizioni dei codoni di start
int main(void){
	char base;
	int i;
	int ATGpos; 		// Posizione all'interno del codone
	int nStartCodons;	// Numero di codoni individuati
	FILE *ifp, *ofp;
	int pos[100000]; // Array di possibili posizioni dei codoni di start
	
	ifp=fopen("EscherichiaColiK-12_mod.fasta","r"); // Apertura file genoma (file modificato nell'intestazione per semplicita')
	ofp=fopen("results.txt","w"); // Il file viene generato se non esiste
	
	i=1;
	ATGpos=0;
	nStartCodons=0;
	while(fscanf(ifp,"%c",&base) == 1){
		//printf("%d\n",i); // Stampa indice carattere appena letto
		//printf("%s",a);
		if(base=='A'){
			//printf("Found %c\n",base); 	// Trovata una A
			ATGpos=1;			// Segna posizione 1 in "presunto ATG" corrente
		}
		else if(ATGpos==1 & base=='T'){		// Trovato AT
			//printf("Found A%c\n",base);	// Segna posizione 2 in "presunto ATG" corrente
			ATGpos=2;
		}
		else if(ATGpos==2 & base=='G'){		// Trovato ATG
			printf("Found ATG, nStartCodons:%d, position:%d\n", nStartCodons+1, i-2);	// Mostra il numero di codoni di start trovati fino ad ora e la posizione dell'ultimo trovato
			pos[nStartCodons]=i-2;	// Salva posizione ultimo codone start trovato
			nStartCodons++;		// Incrementa contatore del numero di codoni di start trovati
			ATGpos=0;		// Reset posizione corrente in "presunto ATG"
		}
		else
			ATGpos=0;		// Non e' un codone di start, reset posizione corrente in "presunto ATG"
			
		i++;				// Incrementa indice posizione in genoma
	}
	fprintf(ofp, "Genome length %d. \n", i);
	fprintf(ofp, "The number of starting codons is %d. \n", nStartCodons);
	fprintf(ofp, "Positions: \n");
	for(int j=0; j<nStartCodons; j++){
		fprintf(ofp, "%d\n",pos[j]);
	}
	fclose(ifp);
	fclose(ofp);
}

// gcc genomeAnalysis.c -o genomeAnalysis
// ./genomeAnalysis
